workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
include:
  - component: $CI_SERVER_HOST/$CI_PROJECT_PATH/zarf-setup@$CI_COMMIT_SHA
    inputs:
      stage: test
  - component: $CI_SERVER_HOST/$CI_PROJECT_PATH/zarf-package-create@$CI_COMMIT_SHA
    inputs:
      stage: test
  - component: $CI_SERVER_HOST/$CI_PROJECT_PATH/zarf-package-publish@$CI_COMMIT_SHA
    inputs:
      stage: test
      path: .
      destination_registry: "$GHCR_PACKAGE_PATH"
      registry_user: "$GHCR_USERNAME"
      registry_password: "$GHCR_PASSWORD"
      registry: "$GHCR_HOST"
#      destination_registry: "oci://ttl.sh/zarf"

zarf-package-publish:
  needs: 
    - zarf-package-create
  dependencies: 
    - zarf-package-create

stages: [build, test]
#stages: [build, test, release]


## Ensure that a project description exists, because it will be important to display
## the resource in the catalog.
#check-description:
#  stage: test
#  needs: []
#  image: badouralix/curl-jq:latest
#  script:
#    - |
#      route="https://$CI_SERVER_HOST/api/v4/projects/$CI_PROJECT_ID"
#      desc=`curl --silent $route | jq '.description'`
#      if [ "$desc" = "null" ]; then
#        echo "Description not set. Please set a projet description"
#      else
#        echo "Description set"
#      fi
#  rules:
#    # add to merge request but not branch pipeline for merge request.
#    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
#    - if: $CI_OPEN_MERGE_REQUESTS
#      when: never
#    - if: $CI_COMMIT_BRANCH # the container_scanning job is only added in branch/MR pipelines.
##    - if: $CI_COMMIT_TAG
## Ensure that a `README.md` exists in the root directory as it represents the
## documentation for the whole components repository.
#check-readme:
#  image: busybox:latest
#  needs: []
#  stage: test
#  script: ls README.md || (echo "Please add a README.md file" && exit 1)
#  rules:
#    # add to merge request but not branch pipeline for merge request.
#    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
#    - if: $CI_OPEN_MERGE_REQUESTS
#      when: never
#    - if: $CI_COMMIT_BRANCH # the container_scanning job is only added in branch/MR pipelines.
#    - if: $CI_COMMIT_TAG
## If we are tagging a release with a specific convention ("v" + number) and all
## previous checks succeeded, we proceed with creating a release automatically.
#create-release:
#  stage: release
#  image: registry.gitlab.com/gitlab-org/release-cli:latest
#  rules:
#    - if: $CI_COMMIT_TAG =~ /\d+/
#  script: echo "Creating release $CI_COMMIT_TAG"
#  release:
#    tag_name: $CI_COMMIT_TAG
#    description: "Release $CI_COMMIT_TAG of components repository $CI_PROJECT_PATH"
